# Broker

You can set broker properties in a configuration file. The file can be provided during startup time as follows -

```
bin/pinot-admin.sh StartBroker -configFileName /path/to/broker.conf
```

`broker.conf` can have the following properties. All properties are defined in this class.

| Property                                          | Default            | Description                                                                                                                                                                                                                                   |
| ------------------------------------------------- | ------------------ | --------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------------- |
| pinot.broker.delayShutdownTimeMs                  | 10 seconds         |                                                                                                                                                                                                                                               |
| pinot.broker.enableTableLevelMetrics              | true               |                                                                                                                                                                                                                                               |
| pinot.broker.query.response.limit                 | Integer.MAX\_VALUE | When config `pinot.broker.enable.query.limit.override`is enabled, reset limit for selection query if it exceeds this value.                                                                                                                   |
| pinot.broker.query.log.length                     | Integer.MAX\_VALUE |                                                                                                                                                                                                                                               |
| pinot.broker.query.log.maxRatePerSecond           | 10000.0            | Maximum queries to be logged per second. Queries with exceptions, or take longer than 1 second are always logged.                                                                                                                             |
| pinot.broker.timeoutMs                            | 10 seconds         | Timeout for Broker Query in Milliseconds                                                                                                                                                                                                      |
| pinot.broker.startup.minResourcePercent           | 100                | Configuration to consider the broker ServiceStatus as being STARTED if the percent of resources (tables) that are ONLINE for this this broker has crossed the threshold percentage of the total number of tables that it is expected to serve |
| pinot.broker.enable.query.limit.override          | false              | Configuration to enable Query LIMIT Override to protect Pinot Broker and Server from fetch too many records back.                                                                                                                             |
| pinot.broker.client.queryPort                     | 8099               | Port to query broker via http (legacy)                                                                                                                                                                                                        |
| pinot.broker.client.access.protocols              |                    | Ingress protocols to query broker (http or https or http,https)                                                                                                                                                                               |
| pinot.broker.client.access.protocols.http.port    |                    | Port to query broker via http                                                                                                                                                                                                                 |
| pinot.broker.client.access.protocols.https.port   |                    | Port to query broker via https                                                                                                                                                                                                                |
| pinot.broker.netty.enabled                        | true               | Enable unsecured netty connections to pinot-server                                                                                                                                                                                            |
| pinot.broker.nettytls.enabled                     | false              | Enable secured netty connections to pinot-server                                                                                                                                                                                              |
| pinot.broker.tls.keystore.path                    |                    | Path to broker TLS keystore                                                                                                                                                                                                                   |
| pinot.broker.tls.keystore.password                |                    | keystore password                                                                                                                                                                                                                             |
| pinot.broker.tls.truststore.path                  |                    | Path to broker TLS truststore                                                                                                                                                                                                                 |
| pinot.broker.tls.truststore.password              |                    | truststore password                                                                                                                                                                                                                           |
| pinot.broker.tls.requires\_client\_auth           | false              | toggle for requiring TLS client auth                                                                                                                                                                                                          |
| pinot.broker.http.server.thread.pool.corePoolSize | 2 \* cores         | Config for the thread-pool used by pinot-broker's http-server.                                                                                                                                                                                |
| pinot.broker.http.server.thread.pool.maxPoolSize  | 2 \* cores         | Config for the thread-pool used by pinot-broker's http-server.                                                                                                                                                                                |


---

# Agent Instructions: Querying This Documentation

If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter:

```
GET https://docs.pinot.apache.org/release-0.12.1/configuration-reference/broker.md?ask=<question>
```

The question should be specific, self-contained, and written in natural language.
The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
